'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GraphSONTextParser = require('./GraphSONTextParser');

var _GraphSONTextParser2 = _interopRequireDefault(_GraphSONTextParser);

var _highland = require('highland');

var _highland2 = _interopRequireDefault(_highland);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Client that handles responses from the application/gremlinbin mimeType
 *
 * @author Dylan Millikin <dylan.millikin@gmail.com>
 */

var GraphSONTextPlugin = function () {
    function GraphSONTextPlugin() {
        _classCallCheck(this, GraphSONTextPlugin);
    }

    _createClass(GraphSONTextPlugin, [{
        key: 'load',


        /**
         * This method loads all the required features for this plugin
         *
         * @param  {Console} main the console object
         * @return {Void}
         */
        value: function load(main) {
            main.parser = new _GraphSONTextParser2.default();
            var driverOptions = {
                accept: "application/gremlinbin",
                executeHandler: function executeHandler(stream, callback) {
                    var errored = false;
                    var objectMode = false;
                    var returnValue = [{ json: [], text: [] }];

                    (0, _highland2.default)(stream).stopOnError(function (err) {
                        // TODO: this does not seem to halt the stream properly, and make
                        // the callback being fired twice. We need to get rid of the ugly
                        // errored variable check.
                        errored = true;
                        callback(err);
                    }).map(function (_ref) {
                        var data = _ref.result.data;

                        objectMode = !_.isArray(data);
                        return data;
                    }).sequence().toArray(function (results) {
                        if (!errored) {
                            var returnCurrent = objectMode ? results[0] : results;
                            if (returnCurrent.length >= 1 && typeof returnCurrent[0].json != "undefined") {
                                returnCurrent.forEach(function (item) {
                                    returnValue[0].json = returnValue[0].json.concat(item.json);
                                    returnValue[0].text = returnValue[0].text.concat(item.text);
                                });
                            } else {
                                returnValue = returnCurrent;
                            }
                            callback(null, returnValue);
                        }
                    });
                }
            };

            main.options.driverOptions = Object.assign(main.options.driverOptions, driverOptions);
        }
    }]);

    return GraphSONTextPlugin;
}();

exports.default = GraphSONTextPlugin;